## libfann 2.2.0+ds

=== CMakeLists.txt ===
PROJECT (FANN)
#SET(CMAKE_VERBOSE_MAKEFILE ON)
cmake_minimum_required(VERSION 2.8)

SET(CMAKE_MODULE_PATH
	${CMAKE_SOURCE_DIR}/cmake/Modules 
)

SET(VERSION 2.2.0)

INCLUDE(DefineInstallationPaths)


configure_file( ${CMAKE_SOURCE_DIR}/cmake/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/src/include/config.h )
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/src/include/)

configure_file( ${CMAKE_SOURCE_DIR}/cmake/fann.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/fann.pc @ONLY )

SET(PKGCONFIG_INSTALL_DIR /lib/pkgconfig)

########### install files ###############

INSTALL_FILES( ${PKGCONFIG_INSTALL_DIR} FILES  fann.pc )

ADD_SUBDIRECTORY( src ) 

################# cpack ################

SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Fast Artificial Neural Network Library (FANN)")
SET(CPACK_PACKAGE_VENDOR "Steffen Nissen")
SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.txt")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING.txt")
SET(CPACK_PACKAGE_VERSION_MAJOR "2")
SET(CPACK_PACKAGE_VERSION_MINOR "2")
SET(CPACK_PACKAGE_VERSION_PATCH "0")
SET(CPACK_GENERATOR "TGZ;ZIP")
SET(CPACK_SOURCE_GENERATOR "TGZ;ZIP")
SET(CPACK_DEBIAN_PACKAGE_MAINTAINER "Steffen Nissen") 
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "CMake ${CMake_VERSION_MAJOR}.${CMake_VERSION_MINOR}")
IF(WIN32 AND NOT UNIX)
  # There is a bug in NSI that does not handle full unix paths properly. Make
  # sure there is at least one set of four (4) backlasshes.
#  SET(CPACK_PACKAGE_ICON "${CMake_SOURCE_DIR}/Utilities/Release\\\\InstallIcon.bmp")
#  SET(CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\MyExecutable.exe")
#  SET(CPACK_NSIS_DISPLAY_NAME "${CPACK_PACKAGE_INSTALL_DIRECTORY} My Famous Project")
  SET(CPACK_NSIS_HELP_LINK "http:\\\\\\\\leenissen.dk/fann/")
  SET(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\leenissen.dk/fann/")
  SET(CPACK_NSIS_CONTACT "sn@leenissen.dk")
  SET(CPACK_NSIS_MODIFY_PATH ON)
ELSE(WIN32 AND NOT UNIX)
#  SET(CPACK_STRIP_FILES "bin/MyExecutable")
#  SET(CPACK_SOURCE_STRIP_FILES "")
ENDIF(WIN32 AND NOT UNIX)
#SET(CPACK_PACKAGE_EXECUTABLES "MyExecutable" "My Executable")
INCLUDE(CPack)

=== examples/Makefile ===
# This makefile is on purpose not made with configure, to show how to use the library
# The make file requires that the fann library is installed (see ../README)

GCC=gcc

TARGETS = xor_train xor_test xor_test_fixed simple_train steepness_train simple_test robot mushroom cascade_train scaling_test scaling_train
DEBUG_TARGETS = xor_train_debug xor_test_debug xor_test_fixed_debug cascade_train_debug

all: $(TARGETS)

%: %.c Makefile
	$(GCC) -O3 $< -o $@ -lfann -lm

%_fixed: %.c Makefile
	$(GCC) -O3 -DFIXEDFANN $< -o $@ -lfixedfann -lm

clean:
	rm -f $(TARGETS) $(DEBUG_TARGETS) xor_fixed.data *.net *~ *.obj *.exe *.tds noscale.txt withscale.txt scale_test_results.txt

runtest: $(TARGETS)
	@echo
	@echo Training network
	./xor_train

	@echo
	@echo Testing network with floats
	./xor_test

	@echo
	@echo Testing network with fixed points
	./xor_test_fixed

#below this line is only for debugging the fann library

rundebugtest: $(DEBUG_TARGETS)
	@echo
	@echo Training network
	./xor_train_debug

	@echo
	@echo Testing network with floats
	./xor_test_debug

	@echo
	@echo Testing network with fixed points
	./xor_test_fixed_debug

#compiletest is used to test whether the library will compile easily in other compilers
compiletest:
	gcc -O3 -ggdb -DDEBUG -Wall -Wformat-security -Wfloat-equal -Wshadow -Wpointer-arith -Wcast-qual -Wsign-compare -pedantic -ansi -I../src/ -I../src/include/ ../src/floatfann.c xor_train.c -o xor_train -lm 
	gcc -O3 -ggdb -DDEBUG -Wall -Wformat-security -Wfloat-equal -Wshadow -Wpointer-arith -Wcast-qual -Wsign-compare -pedantic -ansi -DFIXEDFANN -I../src/ -I../src/include/ ../src/fixedfann.c xor_test.c -o xor_test -lm 
	g++ -O3 -ggdb -DDEBUG -Wall -Wformat-security -Wfloat-equal -Wpointer-arith -Wcast-qual -Wsign-compare -pedantic -ansi -I../src/ -I../src/include/ ../src/floatfann.c xor_train.c -o xor_train -lm 
	g++ -O3 -ggdb -DDEBUG -Wall -Wformat-security -Wfloat-equal -Wpointer-arith -Wcast-qual -Wsign-compare -pedantic -ansi -I../src/ -I../src/include/ ../src/floatfann.c xor_sample.cpp -o xor_train -lm

quickcompiletest:
	gcc -O -ggdb -DDEBUG -Wall -Wformat-security -Wfloat-equal -Wshadow -Wpointer-arith -Wcast-qual -Wsign-compare -pedantic -ansi -I../src/ -I../src/include/ ../src/floatfann.c ../examples/xor_train.c -o ../examples/xor_train -lm 

debug: $(DEBUG_TARGETS)

%_debug: %.c Makefile ../src/*c ../src/include/*h
	$(GCC) -ggdb -DDEBUG -Wall -ansi -I../src/ -I../src/include/ ../src/floatfann.c $< -o $@ -lm 

%_fixed_debug: %.c Makefile ../src/*c ../src/include/*h
	$(GCC) -ggdb -DDEBUG -Wall -ansi -DFIXEDFANN -I../src/ -I../src/include/ ../src/fixedfann.c $< -o $@ -lm

rundebug: $(DEBUG_TARGETS)
	@echo
	@echo Training network
	valgrind --leak-check=yes --show-reachable=yes --leak-resolution=high --db-attach=yes ./xor_train_debug

	@echo
	@echo Testing network with floats
	valgrind --leak-check=yes --show-reachable=yes --leak-resolution=high --db-attach=yes ./xor_test_debug

	@echo
	@echo Testing network with fixed points
	valgrind --leak-check=yes --show-reachable=yes --leak-resolution=high --db-attach=yes ./xor_test_fixed_debug

=== src/CMakeLists.txt ===
ADD_SUBDIRECTORY( include ) 

INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/src/include)
ADD_DEFINITIONS(-D_REENTRANT)
if (WIN32)
ADD_DEFINITIONS(-DFANN_DLL_EXPORTS)
endif (WIN32)
########### next target ###############

SET(floatfann_LIB_SRCS
floatfann.c
)

ADD_LIBRARY(floatfann SHARED ${floatfann_LIB_SRCS})

SET_TARGET_PROPERTIES(floatfann PROPERTIES VERSION ${VERSION} SOVERSION 2 )
INSTALL(TARGETS floatfann DESTINATION ${LIB_INSTALL_DIR} )


########### next target ###############

SET(doublefann_LIB_SRCS
doublefann.c
)

ADD_LIBRARY(doublefann SHARED ${doublefann_LIB_SRCS})

SET_TARGET_PROPERTIES(doublefann PROPERTIES VERSION ${VERSION} SOVERSION 2 )
INSTALL(TARGETS doublefann DESTINATION ${LIB_INSTALL_DIR} )


########### next target ###############

SET(fixedfann_LIB_SRCS
fixedfann.c
)

ADD_LIBRARY(fixedfann SHARED ${fixedfann_LIB_SRCS})

SET_TARGET_PROPERTIES(fixedfann PROPERTIES VERSION ${VERSION} SOVERSION 2 )
INSTALL(TARGETS fixedfann DESTINATION ${LIB_INSTALL_DIR} )


########### next target ###############

SET(fann_LIB_SRCS
floatfann.c
)

ADD_LIBRARY(fann SHARED ${fann_LIB_SRCS})

SET_TARGET_PROPERTIES(fann PROPERTIES VERSION ${VERSION} SOVERSION 2 )
INSTALL(TARGETS fann DESTINATION ${LIB_INSTALL_DIR} )

=== src/include/CMakeLists.txt ===
########### install files ###############

INSTALL_FILES( /include FILES  fann.h doublefann.h fann_internal.h floatfann.h fann_data.h fixedfann.h compat_time.h fann_activation.h fann_cascade.h fann_error.h fann_train.h fann_io.h fann_cpp.h )

=== debian/changelog ===
libfann (2.2.0+ds-3) unstable; urgency=medium

  * Drop package libfann-dbg in favor of automatic dbgsym packages, as per
    https://lists.debian.org/debian-devel/2015/12/msg00262.html
  * d/control:
    - Switch to secure URIs in Vcs-* fields
    - Bump Standards-Version to 3.9.8 (no changes needed)
  * d/rules:
    - Improve version parsing
    - Add hardening=+all,-pie to DEB_BUILD_MAINT_OPTIONS
  * d/copyright:
    - Bump copyright years

 -- Christian Kastner <ckk@debian.org>  Sun, 24 Apr 2016 17:24:51 +0200

libfann (2.2.0+ds-2) unstable; urgency=medium

  * d/rules:
    - Build result uses DEB_HOST_GNU_TYPE, not DEB_HOST_MULTIARCH. Resolves a
      FTBFS on i386.

 -- Christian Kastner <ckk@debian.org>  Sun, 11 Oct 2015 19:05:02 +0200

libfann (2.2.0+ds-1) unstable; urgency=medium

  * New upstream release. Closes: #706352, LP: #1164142
    - The Python bindings have been split out into a separate source package,
      as they are now maintained by an external contributor.
    - Upstream switched to CMake as the build system
  * d/control:
    - Drop the Python packages, and all references to them
    - Drop X-Python-Version
    - Drop Build-Depends on python-all-dev, dh-python, swig
    - Replace Build-Depends on dh-autoreconf with cmake (>= 2.8.5)
    - Drop XS-Testsuite. dpkg now recognizes the Testsuite header, and
      dpkg-source automatically adds one when an autopkgtest suite is found
    - Update Vcs-Browser URL (cgit instead of gitweb on g.d.o)
    - Switch Maintainer email to my @debian.org address
  * d/rules:
    - Update for CMake build
    - Fix dh_auto_test post-execution cleanup
    - Remove all Python-related code
    - Add a get-orig-source target
  * d/copyright:
    - Remove obsolete references to authors. There is no code left in the
      package that can be attributed to these authors
    - Drop Comment documenting the DFSG cleaning; the upstream source is now
      DFSG-free. Pre-compiled Windows binaries are still removed, however;
      hence the +ds suffix
    - Relicense my own patches to LGPL-2.1+ to match upstream
    - Bump copyright years
  * libfann-doc:
    - Rework examples installation
    - Add a new example
    - Update libfann-doc.docs list
  * libfann2:
    - Add 65 new symbols to libfann2.symbols
  * d/tests:
    - Drop test "python-build"
    - Replace Depends on build-essential with libc-dev and gcc
  * d/watch:
    - Upstream moved to GitHub
    - Update for +ds suffix
  * d/TODO:
    - Drop, as there are no TODOs left
  * d/gbp.conf:
    - No patch numbers in .patch filenames
    - Use xz compression
  * d/patches:
    - Drop patch numbers from .patch filenames
  * d/patches (dropped):
    - 0001-Link-python-pyfann-dynamically-instead-of-statically.patch
      0005-Correct-a-typo-in-a-size-comparison.patch
      0007-Do-not-call-swig-unconditionally.patch
      These became obsolete as they pertained to the Python bindings
    - 0003-Patch-upstreams-Makefile.am-reflecting-Debian.patch
      0006-Include-fann_cpp.h-in-dev-package.patch
      These became obsolete through the switch to CMake
  * d/patches (updated):
    - 0002-Link-against-libm.patch
      Update for CMake
  * d/patches (added)
    - cmake-Configurable-pkgconfig-install-destination.patch
    - cmake-Build-static-libraries.patch

 -- Christian Kastner <ckk@debian.org>  Fri, 25 Sep 2015 16:44:35 +0200

=== debian/control ===
Source: libfann
Section: libs
Priority: optional
Maintainer: Christian Kastner <ckk@debian.org>
Build-Depends:
    debhelper (>= 9),
    cmake (>= 2.8.5),
Build-Depends-Indep:
    naturaldocs
Standards-Version: 3.9.8
Homepage: http://leenissen.dk/fann/wp/
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/libfann.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/libfann.git

Package: libfann2
Architecture: any
Multi-Arch: same
Pre-Depends:
    ${misc:Pre-Depends}
Depends:
    ${shlibs:Depends},
    ${misc:Depends}
Suggests:
    libfann-dev (= ${binary:Version}),
    libfann-doc (= ${binary:Version})
Conflicts:
    libfann1
Replaces:
    libfann1
Description: Fast Artificial Neural Network Library
 Fast Artificial Neural Network Library is a free open
 source neural network library, which implements multilayer artificial
 neural networks in C with support for both fully connected and
 sparsely connected networks. Cross-platform execution in both fixed
 and floating point are supported. It includes a framework for easy
 handling of training data sets. It is easy to use, versatile, well
 documented, and fast.
 .
 This package contains the shared libraries.

Package: libfann-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
    ${misc:Depends},
    libfann2 (= ${binary:Version})
Suggests:
    libfann-doc (= ${binary:Version})
Conflicts:
    libfann1-dev
Replaces:
    libfann1-dev
Description: Development libraries and header files for FANN
 Fast Artificial Neural Network Library is a free open
 source neural network library, which implements multilayer artificial
 neural networks in C with support for both fully connected and
 sparsely connected networks. Cross-platform execution in both fixed
 and floating point are supported. It includes a framework for easy
 handling of training data sets. It is easy to use, versatile, well
 documented, and fast.
 .
 This package contains the header files and static libraries which are
 needed for developing libfann applications.

Package: libfann-doc
Section: doc
Architecture: all
Depends:
    ${misc:Depends}
Recommends:
    libfann-dev (= ${binary:Version}),
Description: API documentation for FANN
 Fast Artificial Neural Network Library is a free open
 source neural network library, which implements multilayer artificial
 neural networks in C with support for both fully connected and
 sparsely connected networks. Cross-platform execution in both fixed
 and floating point are supported. It includes a framework for easy
 handling of training data sets. It is easy to use, versatile, well
 documented, and fast.
 .
 This package contains the API documentation in HTML form and some
 introductory material in text form.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# For get-orig-source
PKGDIR := $(dir $(firstword $(MAKEFILE_LIST)))..
DEBVER := $(shell dpkg-parsechangelog -l$(PKGDIR)/debian/changelog -S Version)
UPVER := $(shell echo $(DEBVER) | sed -re 's/\+ds-.*//')

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
export DEB_CFLAGS_MAINT_APPEND = -Wall


%:
	dh $@


override_dh_auto_configure-arch:
	dh_auto_configure -- -DLIB_SUFFIX=/${DEB_HOST_MULTIARCH}


override_dh_auto_configure-indep:
	# Nothing to do


override_dh_auto_build-arch:
	# Library
	dh_auto_build


override_dh_auto_build-indep:
	# Build just the documentation
	mkdir -p doc/html doc/proj
	naturaldocs -i src/include -o HTML doc/html -p doc/proj


override_dh_auto_test-arch:
	# Simulate partial autopkgtest run by providing an ADTTMP and setting
	# CPATH/LIBRARY_PATH/LD_LIBRARY_PATH for the build test
	testrundir=$$(mktemp -d) ;\
		ADTTMP=$$testrundir \
		CPATH=$(CURDIR)/src/include \
		LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/src/ \
		LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/src/ \
	/bin/sh $(CURDIR)/debian/tests/build ;\
	res=$$? ;\
	rm -rf "$$testrundir" ;\
	exit $$res


override_dh_auto_test-indep:
	# Nothing to do


override_dh_auto_install-arch:
	# Library
	dh_auto_install


override_dh_auto_install-indep:
	# Nothing to do


override_dh_install:
	dh_install --fail-missing
	

override_dh_installexamples-indep:
	dh_installexamples -i
	
	# Modify dataset paths in examples to point to libfann-doc datasets. This
	# was not implemented as a patch to upstream to preserve the ability to
	# run upstream's own tests within the source dir.
	sed -i \
		-e 's|\.\./datasets|/usr/share/doc/libfann-doc/examples/datasets|' \
		-e 's|"xor.data"|"/usr/share/doc/libfann-doc/examples/xor.data"|' \
		-e 's|"scaling.data"|"/usr/share/doc/libfann-doc/examples/scaling.data"|' \
		debian/libfann-doc/usr/share/doc/libfann-doc/examples/*.c
	
	# Add Makefile and compile/run instructions for the examples
	cp debian/libfann-doc.examples.Makefile \
		debian/libfann-doc/usr/share/doc/libfann-doc/examples/Makefile
	cp debian/libfann-doc.examples.README \
		debian/libfann-doc/usr/share/doc/libfann-doc/examples/README
	

override_dh_fixperms-indep:
	dh_fixperms -i
	# Remove unnecessary executable bits from training data sets
	chmod 644 debian/libfann-doc/usr/share/doc/libfann-doc/examples/datasets/*


override_dh_link:
	# dh_link does not remove pre-existing destination dirs, only files
	rm -rf debian/libfann-dbg/usr/share/doc/libfann-dbg
	dh_link


override_dh_compress:
	dh_compress -Xexamples -Xjavascript


override_dh_strip:
	dh_strip --dbgsym-migration='libfann-dbg (<< $(DEBVER)~)'


override_dh_auto_clean:
	# Perform regular clean process
	dh_auto_clean
	
	# Remove output generated by naturaldocs
	rm -rf doc/proj doc/html

# Remove upstream's non-DFSG-compliant files
get-orig-source:
	uscan \
		--noconf \
		--download-version $(UPVER) \
		--force-download \
		--check-dirname-level=0 \
		--destdir=$(CURDIR) \
		--rename \
		--repack \
		--compression xz \
		--copyright-file=$(PKGDIR)/debian/files-excluded \
		$(PKGDIR)

=== debian/tests/control ===
Tests: build
Depends: libfann-dev, libc-dev, gcc

=== debian/watch ===
version=3

opts=\
dversionmangle=s/\+ds//,\
repacksuffix=+ds,\
filenamemangle=s/.+\/(\d\S*)\.tar\.gz/libfann-$1\.tar\.gz/ \
https://github.com/libfann/fann/releases .*/(\d\S*)\.tar\.gz
